#pragma once

#include "tokenizer.h"

_token *BASMFile(_token *p);
_token *BASMSetup(_token *p);
_token *BASMGlobals(_token *p);
_token *StaticVarDecl(_token *p);
_token *PieceDecl(_token *p);
_token *ProcDecl(_token *p);
_token *IdentifierList(_token *p);
_token *Identifier(_token *p);
_token *ProcStart(_token *p);
_token *ProcBody(_token *p);
_token *ProcEnd(_token *p);
_token *BASMStmt(_token *p);
_token *kwOp(_token *p);
_token *ArgList(_token *p);
_token *Quoted(_token *p);
_token *Arg(_token *p);
_token *Number(_token *p);
_token *Int(_token *p);
_token *Float(_token *p);
_token *DeclVar(_token *p);
_token *Label(_token *p);
_token *DeclArg(_token *p);
_token *IsValidIdentifier(_token *p);
_token *VarList(_token *p);
_token *LabelName(_token *p);
_token *Link(_token *p);
_token *LinkDLL(_token *p);
_token *DLLName(_token *p);
_token *DLLProcList(_token *p);

#define	EXPECTED_STATIC_VAR_DECL		0x1
#define	EXPECTED_PIECE_DECL				0x2
#define	EXPECTED_PROC_DECL				0x3
#define	EXPECTED_IDENTIFIER_LIST		0x4
#define	EXPECTED_END_STMT				0x5
#define	SPECIFIED_NONE_AFTER_DECL		0x6
#define	EXPECTED_IDENTIFIER				0x7
#define	EXPECTED_PROC_NAME				0x8
#define	DIDNT_SPECIFY_ARGS				0x9
#define	EXPECTED_ARGLIST				0xA
#define	DIDNT_SPECIFY_VAR				0xB
#define	EXPECTED_VARLIST				0xC
#define	EXPECTED_BEGINPROC				0xD
#define	EXPECTED_PROC_START				0xE
#define	EXPECTED_PROC_BODY				0xF
#define	EXPECTED_PROC_END				0x10
#define	EXPECTED_ENDPROC				0x11
#define	END_STMT_AFTER_BEGINPROC		0x12
#define	MISSING_END_STMT_AFTER_ENDPROC	0x13
#define	UNRECOGNIZED_TERM				0x14
#define	TOO_MANY_CONVERSIONS			0x15
#define	CANT_CONVERT_TWICE				0x16
#define	INCOMPATIBLE_CONVERSION_TYPES	0x17
#define	DUPLICATE_EXPORT_SYMBOL			0x18
#define	DUPLICATE_DLL_NAME				0x19
#define	EXPECTED_OPEN_BRACE				0x1A
#define	EXPECTED_DLL_EXPORT_LIST		0x1B
#define	EXPECTED_DLL_NAME				0x1C
#define	EXPECTED_KW_DLL					0x1D
#define	EXPECTED_LINKED_FUNCTION		0x1E
#define	INVALID_DLLLINK_SYMBOL			0x1F
#define	ERROR_AT_TOP_LEVEL				0x20
#define	UNDEFINED_TERM					0x21
#define	INVALID_STRING					0x22
#define	WARNINGS_AS_ERRORS				0x23
#define	DUPLICATE_IDENTIFIER			0x24